searchData={"items":[{"type":"module","title":"Igniter","doc":"Tools for generating and patching code into an Elixir project.","ref":"Igniter.html"},{"type":"function","title":"Igniter.add_issue/2","doc":"Adds an issue to the issues list. Any issues will prevent writing and be displayed to the user.","ref":"Igniter.html#add_issue/2"},{"type":"function","title":"Igniter.add_task/3","doc":"Adds a task to the tasks list. Tasks will be run after all changes have been commited","ref":"Igniter.html#add_task/3"},{"type":"function","title":"Igniter.add_warning/2","doc":"Adds a warning to the warnings list. Warnings will not prevent writing, but will be displayed to the user.","ref":"Igniter.html#add_warning/2"},{"type":"function","title":"Igniter.assign/2","doc":"","ref":"Igniter.html#assign/2"},{"type":"function","title":"Igniter.assign/3","doc":"Stores the key/value pair in `igniter.assigns`","ref":"Igniter.html#assign/3"},{"type":"function","title":"Igniter.compose_task/3","doc":"Finds the `Igniter.Mix.Task` task by name and composes it (calls its `igniter/2`) into the current igniter.","ref":"Igniter.html#compose_task/3"},{"type":"function","title":"Igniter.create_new_elixir_file/3","doc":"Creates a new elixir file in the project with the provided contents. Adds an error if it already exists.","ref":"Igniter.html#create_new_elixir_file/3"},{"type":"function","title":"Igniter.create_or_update_elixir_file/4","doc":"Updates or creates the given file in the project with the provided contents.","ref":"Igniter.html#create_or_update_elixir_file/4"},{"type":"function","title":"Igniter.do_or_dry_run/3","doc":"Executes or dry-runs a given Igniter.\n\nThis takes `argv` to parameterize it as it is generally invoked from a mix task.","ref":"Igniter.html#do_or_dry_run/3"},{"type":"function","title":"Igniter.include_existing_elixir_file/2","doc":"Includes the given file in the project, expecting it to exist. Does nothing if its already been added.","ref":"Igniter.html#include_existing_elixir_file/2"},{"type":"function","title":"Igniter.include_glob/2","doc":"Includes all files matching the given glob, expecting them all (for now) to be elixir files.","ref":"Igniter.html#include_glob/2"},{"type":"function","title":"Igniter.include_or_create_elixir_file/3","doc":"Includes or creates the given file in the project with the provided contents. Does nothing if its already been added.","ref":"Igniter.html#include_or_create_elixir_file/3"},{"type":"function","title":"Igniter.new/0","doc":"Returns a new igniter","ref":"Igniter.html#new/0"},{"type":"function","title":"Igniter.update_elixir_file/3","doc":"Updates the source code of the given elixir file","ref":"Igniter.html#update_elixir_file/3"},{"type":"function","title":"Igniter.update_file/3","doc":"Updates a given file's `Rewrite.Source`","ref":"Igniter.html#update_file/3"},{"type":"function","title":"Igniter.update_glob/3","doc":"Updates all files matching the given glob with the given zipper function.\n\nAdds any new files matching that glob to the igniter first.","ref":"Igniter.html#update_glob/3"},{"type":"type","title":"Igniter.t/0","doc":"","ref":"Igniter.html#t:t/0"},{"type":"type","title":"Igniter.zipper_updater/0","doc":"","ref":"Igniter.html#t:zipper_updater/0"},{"type":"module","title":"Igniter.Application","doc":"Codemods and tools for working with Application modules.","ref":"Igniter.Application.html"},{"type":"function","title":"Igniter.Application.add_new_child/2","doc":"Adds a new child to the `children` list in the application file","ref":"Igniter.Application.html#add_new_child/2"},{"type":"function","title":"Igniter.Application.app_name/0","doc":"Returns the name of the current application.","ref":"Igniter.Application.html#app_name/0"},{"type":"function","title":"Igniter.Application.create_app/2","doc":"","ref":"Igniter.Application.html#create_app/2"},{"type":"function","title":"Igniter.Application.do_add_child/3","doc":"","ref":"Igniter.Application.html#do_add_child/3"},{"type":"module","title":"Igniter.Code.Common","doc":"General purpose utilities for working with `Sourceror.Zipper`.","ref":"Igniter.Code.Common.html"},{"type":"function","title":"Igniter.Code.Common.add_code/3","doc":"Adds the provided code to the zipper.\n\nUse the `placement` to determine if the code goes `:after` or `:before` the current node.","ref":"Igniter.Code.Common.html#add_code/3"},{"type":"function","title":"Example: - Igniter.Code.Common.add_code/3","doc":"```elixir\nexisting_code = \"\"\"\nIO.inspect(\"Hello, world!\")\n\"\"\"\n|> Sourceror.parse_string!()\n\nnew_code = \"\"\"\nIO.inspect(\"Goodbye, world!\")\n\"\"\"\n\nexisting_code\n|> Sourceror.Zipper.zip()\n|> Igniter.Common.add_code(new_code)\n|> Sourceror.Zipper.root()\n|> Sourceror.to_string()\n```\n\nWhich will produce\n\n```elixir\n\"\"\"\nIO.inspect(\"Hello, world!\")\n|> Sourceror.to_string()\n\"\"\"\n```","ref":"Igniter.Code.Common.html#add_code/3-example"},{"type":"function","title":"Igniter.Code.Common.maybe_move_to_block/1","doc":"Enters a block with a single child, and moves to that child,\nor returns the zipper unmodified","ref":"Igniter.Code.Common.html#maybe_move_to_block/1"},{"type":"function","title":"Igniter.Code.Common.move_right/2","doc":"Moves right in the zipper, until the provided predicate returns `true`.\n\nReturns `:error` if the end is reached without finding a match.","ref":"Igniter.Code.Common.html#move_right/2"},{"type":"function","title":"Igniter.Code.Common.move_to/2","doc":"Moves to the next node that matches the predicate.","ref":"Igniter.Code.Common.html#move_to/2"},{"type":"function","title":"Igniter.Code.Common.move_to_cursor/2","doc":"Matches and moves to the location of a `__cursor__` in provided source code.\n\nUse `__cursor__()` to match a cursor in the provided source code. Use `__` to skip any code at a point.\n\nFor example:\n\n```elixir\nzipper =\n  \"\"\"\n  if true do\n    10\n  end\n  \"\"\"\n  |> Sourceror.Zipper.zip()\n\npattern =\n  \"\"\"\n  if __ do\n    __cursor__\n  end\n  \"\"\"\n\nzipper\n|> Igniter.Code.Common.move_to_cursor(pattern)\n|> Zipper.subtree()\n|> Zipper.node()\n# => 10\n```","ref":"Igniter.Code.Common.html#move_to_cursor/2"},{"type":"function","title":"Igniter.Code.Common.move_to_cursor_match_in_scope/2","doc":"Moves to the cursor that matches the provided pattern or one of the provided patterns, in the current scope.\n\nSee `move_to_cursor/2` for an example of a pattern","ref":"Igniter.Code.Common.html#move_to_cursor_match_in_scope/2"},{"type":"function","title":"Igniter.Code.Common.move_to_do_block/1","doc":"Moves to a do block for the current call.\n\nFor example, at a node like:\n\n```elixir\nfoo do\n  10\nend\n```\n\nYou would get a zipper back at `10`.","ref":"Igniter.Code.Common.html#move_to_do_block/1"},{"type":"macro","title":"Igniter.Code.Common.move_to_pattern/2","doc":"Moves to the next node that matches the given pattern.","ref":"Igniter.Code.Common.html#move_to_pattern/2"},{"type":"macro","title":"Igniter.Code.Common.node_matches_pattern?/2","doc":"Returns `true` if the current node matches the given pattern.","ref":"Igniter.Code.Common.html#node_matches_pattern?/2"},{"type":"function","title":"Igniter.Code.Common.nodes_equal?/2","doc":"","ref":"Igniter.Code.Common.html#nodes_equal?/2"},{"type":"function","title":"Igniter.Code.Common.nth_right/2","doc":"Moves the zipper right n times, returning `:error` if it can't move that many times.","ref":"Igniter.Code.Common.html#nth_right/2"},{"type":"function","title":"Igniter.Code.Common.within/2","doc":"Runs the function `fun` on the subtree of the currently focused `node` and\nreturns the updated `zipper`.\n\n`fun` must return {:ok, zipper} or `:error`, which may be positioned at the top of the subtree.","ref":"Igniter.Code.Common.html#within/2"},{"type":"module","title":"Igniter.Code.Function","doc":"Utilities for working with functions.","ref":"Igniter.Code.Function.html"},{"type":"function","title":"Igniter.Code.Function.append_argument/2","doc":"","ref":"Igniter.Code.Function.html#append_argument/2"},{"type":"macro","title":"Igniter.Code.Function.argument_matches_pattern?/3","doc":"Returns `true` if the argument at the provided index exists and matches the provided pattern","ref":"Igniter.Code.Function.html#argument_matches_pattern?/3"},{"type":"function","title":"Igniter.Code.Function.argument_matches_predicate?/3","doc":"","ref":"Igniter.Code.Function.html#argument_matches_predicate?/3"},{"type":"function","title":"Igniter.Code.Function.function_call?/1","doc":"Returns `true` if the node is a function call","ref":"Igniter.Code.Function.html#function_call?/1"},{"type":"function","title":"Igniter.Code.Function.function_call?/2","doc":"Returns `true` if the node is a function call of the given name","ref":"Igniter.Code.Function.html#function_call?/2"},{"type":"function","title":"Igniter.Code.Function.function_call?/3","doc":"Returns `true` if the node is a function call of the given name and arity","ref":"Igniter.Code.Function.html#function_call?/3"},{"type":"function","title":"Igniter.Code.Function.move_to_function_call_in_current_scope/4","doc":"Moves to a function call by the given name and arity, matching the given predicate, in the current scope","ref":"Igniter.Code.Function.html#move_to_function_call_in_current_scope/4"},{"type":"function","title":"Igniter.Code.Function.move_to_nth_argument/2","doc":"","ref":"Igniter.Code.Function.html#move_to_nth_argument/2"},{"type":"function","title":"Igniter.Code.Function.pipeline?/1","doc":"","ref":"Igniter.Code.Function.html#pipeline?/1"},{"type":"function","title":"Igniter.Code.Function.update_nth_argument/3","doc":"","ref":"Igniter.Code.Function.html#update_nth_argument/3"},{"type":"module","title":"Igniter.Code.Keyword","doc":"Utilities for working with keyword.","ref":"Igniter.Code.Keyword.html"},{"type":"function","title":"Igniter.Code.Keyword.keyword_has_path?/2","doc":"Returns true if the node is a nested keyword list containing a value at the given path.","ref":"Igniter.Code.Keyword.html#keyword_has_path?/2"},{"type":"function","title":"Igniter.Code.Keyword.keywordify/2","doc":"Puts into nested keyword lists represented by `path`","ref":"Igniter.Code.Keyword.html#keywordify/2"},{"type":"function","title":"Igniter.Code.Keyword.put_in_keyword/4","doc":"Puts a value at a path into a keyword, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Keyword.html#put_in_keyword/4"},{"type":"function","title":"Igniter.Code.Keyword.remove_keyword_key/2","doc":"Removes a key from a keyword list if present. Returns `:error` only if the node is not a list","ref":"Igniter.Code.Keyword.html#remove_keyword_key/2"},{"type":"function","title":"Igniter.Code.Keyword.set_keyword_key/4","doc":"","ref":"Igniter.Code.Keyword.html#set_keyword_key/4"},{"type":"module","title":"Igniter.Code.List","doc":"Utilities for working with lists.","ref":"Igniter.Code.List.html"},{"type":"function","title":"Igniter.Code.List.append_new_to_list/3","doc":"Appends `quoted` to the list unless it is alread present, determined by `equality_pred`.","ref":"Igniter.Code.List.html#append_new_to_list/3"},{"type":"function","title":"Igniter.Code.List.append_to_list/2","doc":"Appends `quoted` to the list","ref":"Igniter.Code.List.html#append_to_list/2"},{"type":"function","title":"Igniter.Code.List.find_list_item_index/2","doc":"Finds the index of the first list item that satisfies `pred`","ref":"Igniter.Code.List.html#find_list_item_index/2"},{"type":"function","title":"Igniter.Code.List.list?/1","doc":"Returns true if the `zipper` is at a list literal","ref":"Igniter.Code.List.html#list?/1"},{"type":"function","title":"Igniter.Code.List.move_to_list_item/2","doc":"Moves to the list item matching the given predicate","ref":"Igniter.Code.List.html#move_to_list_item/2"},{"type":"function","title":"Igniter.Code.List.prepend_new_to_list/3","doc":"Prepends `quoted` to the list unless it is alread present, determined by `equality_pred`.","ref":"Igniter.Code.List.html#prepend_new_to_list/3"},{"type":"function","title":"Igniter.Code.List.prepend_to_list/2","doc":"Prepends `quoted` to the list","ref":"Igniter.Code.List.html#prepend_to_list/2"},{"type":"function","title":"Igniter.Code.List.remove_index/2","doc":"Removes the item at the given index, returning `:error` if nothing is at that index","ref":"Igniter.Code.List.html#remove_index/2"},{"type":"type","title":"Igniter.Code.List.equality_pred/0","doc":"","ref":"Igniter.Code.List.html#t:equality_pred/0"},{"type":"module","title":"Igniter.Code.Map","doc":"Utilities for working with maps.","ref":"Igniter.Code.Map.html"},{"type":"function","title":"Igniter.Code.Map.mappify/2","doc":"Puts a value into nested maps at the given path","ref":"Igniter.Code.Map.html#mappify/2"},{"type":"function","title":"Igniter.Code.Map.put_in_map/4","doc":"Puts a value at a path into a map, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Map.html#put_in_map/4"},{"type":"function","title":"Igniter.Code.Map.set_map_key/4","doc":"Puts a key into a map, calling `updater` on the zipper at the value if the key is already present","ref":"Igniter.Code.Map.html#set_map_key/4"},{"type":"module","title":"Igniter.Code.Module","doc":"Utilities for working with Elixir modules","ref":"Igniter.Code.Module.html"},{"type":"function","title":"Igniter.Code.Module.module_name/1","doc":"Given a suffix, returns a module name with the prefix of the current project","ref":"Igniter.Code.Module.html#module_name/1"},{"type":"function","title":"Igniter.Code.Module.module_name_prefix/0","doc":"The module name prefix based on the mix project's module name","ref":"Igniter.Code.Module.html#module_name_prefix/0"},{"type":"function","title":"Igniter.Code.Module.move_to_def/3","doc":"","ref":"Igniter.Code.Module.html#move_to_def/3"},{"type":"function","title":"Igniter.Code.Module.move_to_defp/3","doc":"","ref":"Igniter.Code.Module.html#move_to_defp/3"},{"type":"function","title":"Igniter.Code.Module.move_to_module_using/2","doc":"Moves the zipper to the body of a module that `use`s the provided module (or one of the provided modules).","ref":"Igniter.Code.Module.html#move_to_module_using/2"},{"type":"function","title":"Igniter.Code.Module.move_to_use/2","doc":"Moves the zipper to the `use` statement for a provided module.","ref":"Igniter.Code.Module.html#move_to_use/2"},{"type":"function","title":"Igniter.Code.Module.parse/1","doc":"Parses a string into a module name","ref":"Igniter.Code.Module.html#parse/1"},{"type":"function","title":"Igniter.Code.Module.proper_location/1","doc":"Returns the idiomatic file location for a given module","ref":"Igniter.Code.Module.html#proper_location/1"},{"type":"module","title":"Igniter.Code.Tuple","doc":"Utilities for working with tuples.","ref":"Igniter.Code.Tuple.html"},{"type":"function","title":"Igniter.Code.Tuple.tuple?/1","doc":"Returns `true` if the zipper is at a literal tuple, `false` if not.","ref":"Igniter.Code.Tuple.html#tuple?/1"},{"type":"function","title":"Igniter.Code.Tuple.tuple_elem/2","doc":"Returns a zipper at the tuple element at the given index, or `:error` if the index is out of bounds.","ref":"Igniter.Code.Tuple.html#tuple_elem/2"},{"type":"module","title":"Igniter.Config","doc":"Codemods and utilities for modifying Elixir config files.","ref":"Igniter.Config.html"},{"type":"function","title":"Igniter.Config.configure/6","doc":"Sets a config value in the given configuration file, updating it with `updater` if it is already set.","ref":"Igniter.Config.html#configure/6"},{"type":"function","title":"Igniter.Config.configure_new/5","doc":"Sets a config value in the given configuration file, if it is not already set.","ref":"Igniter.Config.html#configure_new/5"},{"type":"function","title":"Igniter.Config.configures?/3","doc":"Returns `true` if the given configuration path is set somewhere after the provided zipper.","ref":"Igniter.Config.html#configures?/3"},{"type":"function","title":"Igniter.Config.modify_configuration_code/5","doc":"Modifies elixir configuration code starting at the configured zipper.\n\nIf you want to set configuration, use `configure/6` or `configure_new/5` instead. This is a lower-level\ntool for modifying configuration files when you need to adjust some specific part of them.","ref":"Igniter.Config.html#modify_configuration_code/5"},{"type":"module","title":"Igniter.Debug","doc":"Tools for debugging zippers.","ref":"Igniter.Debug.html"},{"type":"function","title":"Igniter.Debug.puts_ast_at_node/1","doc":"Puts the ast at the node of the zipper to the console","ref":"Igniter.Debug.html#puts_ast_at_node/1"},{"type":"function","title":"Igniter.Debug.puts_code_at_node/1","doc":"Puts the formatted code at the node of the zipper to the console","ref":"Igniter.Debug.html#puts_code_at_node/1"},{"type":"module","title":"Igniter.Deps","doc":"Codemods and utilities for managing dependencies declared in mix.exs","ref":"Igniter.Deps.html"},{"type":"function","title":"Igniter.Deps.add_dependency/4","doc":"","ref":"Igniter.Deps.html#add_dependency/4"},{"type":"function","title":"Igniter.Deps.get_dependency_declaration/2","doc":"","ref":"Igniter.Deps.html#get_dependency_declaration/2"},{"type":"module","title":"Igniter.Formatter","doc":"Codemods and utilities for interacting with `.formatter.exs` files","ref":"Igniter.Formatter.html"},{"type":"function","title":"Igniter.Formatter.add_formatter_plugin/2","doc":"Adds a new plugin to the list of plugins in the root `.formatter.exs`","ref":"Igniter.Formatter.html#add_formatter_plugin/2"},{"type":"function","title":"Igniter.Formatter.import_dep/2","doc":"Adds a new dep to the list of imported deps in the root `.formatter.exs`","ref":"Igniter.Formatter.html#import_dep/2"},{"type":"behaviour","title":"Igniter.Mix.Task","doc":"A behaviour for implementing a Mix task that is enriched to be composable with other Igniter tasks.","ref":"Igniter.Mix.Task.html"},{"type":"callback","title":"Igniter.Mix.Task.igniter/2","doc":"All the generator behavior happens here, you take an igniter and task arguments, and return an igniter.","ref":"Igniter.Mix.Task.html#c:igniter/2"},{"type":"callback","title":"Igniter.Mix.Task.supports_umbrella?/0","doc":"Whether or not it supports being run in the root of an umbrella project\n\nAt the moment, this is still experimental and we suggest not turning it on.","ref":"Igniter.Mix.Task.html#c:supports_umbrella?/0"},{"type":"module","title":"Igniter.Version","doc":"Utilities for working versions and version requirements","ref":"Igniter.Version.html"},{"type":"function","title":"Igniter.Version.version_string_to_general_requirement/1","doc":"","ref":"Igniter.Version.html#version_string_to_general_requirement/1"},{"type":"function","title":"Igniter.Version.version_string_to_general_requirement!/1","doc":"Provides a general requirement for a given version string.\n\nFor example\n\n`3.1.2` would be `~> 3.0`\nand\n`0.2.4` would be `~> 0.2`","ref":"Igniter.Version.html#version_string_to_general_requirement!/1"},{"type":"task","title":"mix igniter.install","doc":"Install a package or packages, and run any associated installers.","ref":"Mix.Tasks.Igniter.Install.html"},{"type":"task","title":"Args - mix igniter.install","doc":"mix igniter.install package1 package2 package3","ref":"Mix.Tasks.Igniter.Install.html#module-args"},{"type":"task","title":"Package formats - mix igniter.install","doc":"* `package` - The latest version of the package will be installed, pinned at the\n   major version, or minor version if there is no major version yet.\n* `package@version` - The package will be installed at the specified version.\n   If the version given is generic, like `3.0`, it will be pinned as described above.\n   if it is specific, like `3.0.1`, it will be pinned at that *exact* version with `==`.\n* `package@git:git_url` - The package will be installed from the specified git url.\n* `package@github:project/repo` - The package will be installed from the specified github repo.\n* `package@local:path/to/local` - The package will be installed from the specified local path.","ref":"Mix.Tasks.Igniter.Install.html#module-package-formats"},{"type":"task","title":"Switches - mix igniter.install","doc":"* `--dry-run` - `d` - Run the task without making any changes.\n* `--yes` - `y` - Automatically answer yes to any prompts.\n* `--example` - `e` - Request that installed packages include initial example code.","ref":"Mix.Tasks.Igniter.Install.html#module-switches"},{"type":"extras","title":"Home","doc":"[![CI](https://github.com/ash-project/igniter/actions/workflows/elixir.yml/badge.svg)](https://github.com/ash-project/igniter/actions/workflows/elixir.yml)\n[![Hex version badge](https://img.shields.io/hexpm/v/igniter.svg)](https://hex.pm/packages/igniter)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/igniter)\n\n# Igniter\n\nIgniter is a code generation and project patching framework.\n\nFor library authors, this is a tool kit for writing smarter generators that can semantically modify existing files, and all sorts of useful tools for doing so.\n\nFor end-users, this means `mix igniter.install  `, which will _add it to your mix.exs automatically_ and then run that library's installer if it has one. Even when libraries don't have an installer, or use igniter, this behavior makes it useful to keep around.","ref":"readme.html"},{"type":"extras","title":"State of the project - Home","doc":"This project is in early beta. There is _so much to add_! There are lots of DX/UX things to improve, but it does already provide some great utility. Contributions welcome!","ref":"readme.html#state-of-the-project"},{"type":"extras","title":"Limitations - Home","doc":"Right now, all files that are touched are formatted in their entirety. This may be a deal breaker for some users. I believe that we can solve this without changing the fundemental design of the project, but it is not a high priority in the early stages.","ref":"readme.html#limitations"},{"type":"extras","title":"Installation - Home","doc":"Igniter can be added to an existing elixir project by adding it to your dependencies:\n\n```elixir\n{:igniter, \"~> 0.1\", only: [:dev]}\n```\n\nYou can also generate new projects with igniter preinstalled, and run installers in the same command.\n\n```\nmix igniter.new app_name --install ash\n```\n\nTo use this command, install the archive:\n\n```elixir\nmix archive.install hex igniter_new\n```","ref":"readme.html#installation"},{"type":"extras","title":"Patterns - Home","doc":"Mix tasks built with igniter are both individually callable, _and_ composable. This means that tasks can call eachother, and also end users can create and customize their own generators composing existing tasks.","ref":"readme.html#patterns"},{"type":"extras","title":"Installers - Home","doc":"Igniter will look for a task called ` .install` when the user runs `mix igniter.install  `, and will run it after installing and fetching dependencies.","ref":"readme.html#installers"},{"type":"extras","title":"Generators/Patchers - Home","doc":"These can be run like any other mix task, or composed together. For example, lets say that you wanted to have your own `Ash.Resource` generator, that starts with the default `mix ash.gen.resource` task, but then adds or modifies files:\n\n```elixir\n# in lib/mix/tasks/my_app.gen.resource.ex\ndefmodule Mix.Tasks.MyApp.Gen.Resource do\n  use Igniter.Mix.Task\n\n  def igniter(igniter, [resource | _] = argv) do\n    resource = Igniter.Code.Module.parse(resource)\n    my_special_thing = Module.concat([resource, SpecialThing])\n    location = Igniter.Code.Module.proper_location(my_special_thing)\n\n    igniter\n    |> Igniter.compose_task(\"ash.gen.resource\", argv)\n    |> Igniter.create_new_elixir_file(location, \"\"\"\n    defmodule #{inspect(my_special_thing)} do\n      # this is the special thing for #{inspect()}\n    end\n    \"\"\")\n  end\nend\n```","ref":"readme.html#generators-patchers"},{"type":"extras","title":"Writing Generators","doc":"# Writing Generators\n\nIn `Igniter`, generators are done as a wrapper around `Mix.Task`, allowing them to be called individually or composed as part of a task. Since an example is worth a thousand words, lets take a look at an example that generates a file and ensures a configuration is set in the user's `config.exs`.\n\n```elixir\n# lib/mix/tasks/your_lib.gen.your_thing.ex\ndefmodule Mix.Tasks.YourLib.Gen.YourThing do\n  use Igniter.Mix.Task\n\n  def igniter(igniter, [module_name | _ ] = argv) do\n    module_name = Igniter.Module.parse(module_name)\n    path = Igniter.Module.proper_location(module_name)\n    app_name = Igniter.Application.app_name()\n\n    igniter\n    |> Igniter.create_new_elixir_file(igniter, path, \"\"\"\n    defmodule #{inspect(module_name)} do\n      use YourLib.Thing\n\n      ...some_code\n    end\n    \"\"\")\n    |> Igniter.Config.configure(\n      \"config.exs\",\n      app_name,\n      [:list_of_things],\n      [module_name],\n      &Igniter.Code.List.prepend_new_to_list(&1, module_name)\n    )\n  end\nend\n```\n\nNow, your users can run\n\n`mix your_lib.gen.your_thing MyApp.MyModuleName`\n\nand it will present them with a diff, creating a new file and updating their `config.exs`.\n\nAdditionally, other generators can \"compose\" this generator using `Igniter.compose_task/3`\n\n```elixir\nigniter\n|> Igniter.compose_task(Mix.Tasks.YourLib.Gen.YourThing, [\"MyApp.MyModuleName\"])\n|> Igniter.compose_task(Mix.Tasks.YourLib.Gen.YourThing, [\"MyApp.SomeOtherName\"])\n```","ref":"writing-generators.html"},{"type":"extras","title":"Writing a library installer - Writing Generators","doc":"Igniter will look for a mix task called `your_library.install` when a user runs `mix igniter.install your_library`. As long as it has the correct name, it will be run automatically as part of installation!","ref":"writing-generators.html#writing-a-library-installer"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v0.1.3](https://github.com/ash-project/igniter/compare/v0.1.2...v0.1.3) (2024-06-13)","ref":"changelog.html"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support space-separated installers\n\n## [v0.1.2](https://github.com/ash-project/igniter/compare/v0.1.1...v0.1.2) (2024-06-13)","ref":"changelog.html#improvements"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* remove unsupportable package installation symbols\n\n* don't run `mix deps.get` if dependency changes are aborted\n\n## [v0.1.1](https://github.com/ash-project/igniter/compare/v0.1.0...v0.1.1) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* always format the file even if no `.formatter.exs` exists\n\n## [v0.1.0](https://github.com/ash-project/igniter/compare/v0.1.0...v0.1.0) (2024-06-13)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* handle existing deps when they are not local properly","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Improvements: - Change Log","doc":"* ignore installer tasks that are not igniter tasks\n\n* draw the rest of the owl\n\n* add installer archive\n\n* more module helpers\n\n* wrap code in `==code==` so you can tell what is being `puts`\n\n* add CI/build and get it passing locally","ref":"changelog.html#improvements"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}